﻿//using Hotline.Application.Identity;
//using Hotline.Application.Snapshot;
//using Hotline.Share.Dtos.Article;
//using Hotline.Share.Dtos.Snapshot;
//using Hotline.Share.Enums;
//using Hotline.Share.Enums.Snapshot;
//using Hotline.Share.Tools;
//using Hotline.Snapshot;
//using Shouldly;
//using XF.Domain.Repository;
//using XF.Utility.EnumExtensions;

//namespace Hotline.Application.Tests.Application;
//public class SnapshotApplicationTest
//{
//    private readonly ISnapshotApplication _snapshotApplication;
//    private readonly IIdentityAppService _identityAppService;
//    private readonly IRepository<RedPackRecord> _redPackRecordRepository;

//    public SnapshotApplicationTest(ISnapshotApplication snapshotApplication, IIdentityAppService identityAppService, IRepository<RedPackRecord> redPackRecordRepository)
//    {
//        _snapshotApplication = snapshotApplication;
//        _identityAppService = identityAppService;
//        _redPackRecordRepository = redPackRecordRepository;
//    }

//    [Fact]
//    public async Task GetHomePage_Test()
//    {
//        var result = await _snapshotApplication.GetHomePageAsync();
//        result.Any().ShouldBe(true, "首页数据为空");
//        result.First().DisplayOrder.ShouldBe(1, "排序异常");
//    }

//    [Fact]
//    public async Task GetBulletins_Test()
//    {
//        var homePage = await _snapshotApplication.GetHomePageAsync();
//        var inDto = new BulletinInDto
//        {
//            IndustryId = homePage.First(m => m.Name == "文化旅游").Id,
//        };
//        var items = await _snapshotApplication.GetBulletinsAsync(inDto);
//        items.ShouldNotBeNull();
//        items.Any().ShouldBe(true, "公告数据为空");
//        items.Any(m => m.Title.IsNullOrEmpty()).ShouldBe(false, "标题错误");
//        items.Any(m => m.Content.IsNullOrEmpty()).ShouldBe(false, "内容错误");
//        items.Any(m => m.Id.IsNullOrEmpty()).ShouldBe(false, "Id错误");
//    }

//    [Fact]
//    public async Task GetSnapshotUserInfo_Test()
//    {
//        var result = await _snapshotApplication.GetSnapshotUserInfoAsync();
//        result.ShouldNotBeNull();
//        result.PhoneNumber.ShouldNotBeNullOrEmpty();
//    }

//    [Fact]
//    public async Task GetThirdToken_Test()
//    {
//        var result = await _identityAppService.GetThredTokenAsync(new ThirdTokenInDto { Code = "0e3dql000zdwLS1ZRn000Z3SFR3dql00" });
//        result.Code.ShouldBe(0);
//        result.Result.Token.ShouldNotBeNull();
//        result.Result.UserType.ShouldBe(EReadPackUserType.Citizen);
//    }

//    [Theory]
//    [InlineData("")]
//    [InlineData("测")]
//    public async Task SnapshotOrder_Test(string key)
//    {
//        var dto = new OrderInDto();
//        dto.KeyWords = key;
//        var page = await _snapshotApplication.GetSnapshotOrdersAsync(dto);
//        page.Total.ShouldNotBe(0);
//        page.Items.FirstOrDefault()?.IndustryName.ShouldNotBeNullOrEmpty();
//        page.Items.FirstOrDefault()?.OrderNo.ShouldNotBeNullOrEmpty();
//        page.Items.FirstOrDefault()?.StatusText.ShouldNotBeNullOrEmpty();
//        page.Items.FirstOrDefault()?.Area.ShouldNotBeNullOrEmpty();
//    }

//    [Theory]
//    [InlineData(EOrderQueryStatus.All, 3)]
//    [InlineData(EOrderQueryStatus.Reply, 2)]
//    [InlineData(EOrderQueryStatus.NoReply, 1)]
//    [InlineData(EOrderQueryStatus.Appraise, 1)]
//    public async Task SnapshotOrderStatus_Test(EOrderQueryStatus status, int count)
//    {
//        var dto = new OrderInDto { Status = status };
//        var page = await _snapshotApplication.GetSnapshotOrdersAsync(dto);
//        page.Total.ShouldNotBe(0, $"状态:{status.GetDescription()} 数据为空");
//        page.Total.ShouldBe(count, $"状态:{status.GetDescription()} 数据条数错误");
//        page.Items.FirstOrDefault()?.IndustryName.ShouldNotBeNullOrEmpty();
//        page.Items.FirstOrDefault()?.OrderNo.ShouldNotBeNullOrEmpty();
//        page.Items.FirstOrDefault()?.StatusText.ShouldNotBeNullOrEmpty();
//        page.Items.FirstOrDefault()?.Area.ShouldNotBeNullOrEmpty();

//        dto.PageIndex = 2;
//        page = await _snapshotApplication.GetSnapshotOrdersAsync(dto);
//        page.Items.Count.ShouldBe(0);
//    }

//    [Fact]
//    public async Task GetSnapshotOrderDetail_Test()
//    {
//        var page = await _snapshotApplication.GetSnapshotOrdersAsync(new OrderInDto());
//        var id = page.Items.First().Id;
//        var detail = await _snapshotApplication.GetSnapshotOrderDetailAsync(id);
//        detail.Id.ShouldBe(id);
//        detail.IndustryName.ShouldNotBeNull();
//    }

//    [Theory]
//    [InlineData(2, 2)]
//    [InlineData(12, 12)]
//    public async Task GetRedPackDateAsync(int count, int exp)
//    {
//        var items = await _snapshotApplication.GetRedPackDateAsync(new RedPackDateInDto { Count = count});
//        items.Count.ShouldNotBe(0, "0数据");
//        items.Count.ShouldBe(exp, $"应该:{exp}, 实际 {items.Count}");
//    }

//    [Theory]
//    [InlineData(ERedPackPickupStatus.Unreceived)]
//    [InlineData(ERedPackPickupStatus.Received)]
//    public async Task GetRedPacksAsync(ERedPackPickupStatus status)
//    {
//        var page = await _snapshotApplication.GetRedPacksAsync(new RedPacksInDto { Status = status});
//        page.Total.ShouldNotBe(0, "数据不应该为空");
//    }

//    [Fact]
//    public async Task GetBulletinsDetail_Test()
//    {
//        var detail = await _snapshotApplication.GetBulletinsDetailAsync("08dc788f-20f4-4bf1-83d3-b5a8a4f395b0");
//        detail.Id.ShouldNotBeNullOrEmpty();
//        detail.Title.ShouldNotBeNullOrEmpty();
//        detail.Content.ShouldNotBeNullOrEmpty();
//    }

//    [Fact]
//    public async Task InitRedPackDataAsync()
//    {
//        for (int i = 0; i < 12; i++)
//        {
//            var now = DateTime.Now;
//            var entity = new RedPackRecord
//            {
//                OrderId = "111111111",
//                Amount = 10 * 1000,
//                CreationTime = new DateTime(2024, i + 1, 02, now.Hour, now.Minute, now.Second),
//                WXOpenId = "测试生成的OpenId",
//                PickupStatus = ERedPackPickupStatus.Received,
//            };
//            await _redPackRecordRepository.AddAsync(entity);
//        }
//    }
//}
